diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp
index 235d5cb..4fe565f 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp
@@ -192,495 +376,654 @@ void Spy(Wiimote* wm_, const void* data_, int size_)
 
 	case WM_READ_DATA:
 	{
-		if (logCom) Name.append("R");
-		size = sizeof(wm_read_data);
-
 		wm_read_data* rd = (wm_read_data*)sr->data;
 		u32 address = Common::swap24(rd->address);
-		u8 addressLO = address & 0xFFFF;
 		address &= 0xFEFFFF;
-		u16 size = Common::swap16(rd->size);
-		u8 *const block = new u8[size];
+		rd->size = Common::swap16(rd->size);
+		u8 *const block = new u8[rd->size];
+
 		void *region_ptr = NULL;
+		int region_size = 0;
 
-		dataRep.push(((data[2]>>1)<<16) + ((data[3])<<8) + addressLO);
+		g_rd = *rd;
 
-		switch(data[2]>>1)
+		if (log_com)
+		{
+			com.append("READ");
+			formatted.append(StringFromFormat("%02x %06x %04x", rd->space, address, rd->size));
+		}
+
+		switch(rd->space)
 		{
 		case WM_SPACE_EEPROM:
-			if (logCom) Name.append(" REG_EEPROM");
-			if (!emu)
-				memcpy(block, wm->m_eeprom + address, size);
+			if (log_com) com.append(" REG_EEPROM");
+			if (save)
+				memcpy(block, wm->m_eeprom + address, rd->size);
 			break;
+
 		case WM_SPACE_REGS1:
 		case WM_SPACE_REGS2:
-			// ignore second byte for extension area
-			if (address>>16 == 0xA4) address &= 0xFF00FF;
+
+			if (address >> 16 == 0xA4)
+				address &= 0xFF00FF;
+			reg_type = address >> 16;
+
 			const u8 region_offset = (u8)address;
-			switch(data[3])
+
+			switch(reg_type)
 			{
-			case 0xa2:
-				if (logCom) Name.append(" REG_SPEAKER");
+			case WIIMOTE_REG_SPEAKER:
+				if (log_com) com.append(" REG_SPEAKER");
 				region_ptr = &wm->m_reg_speaker;
+				region_size = WIIMOTE_REG_SPEAKER_SIZE;
 				break;
-			case 0xa4:
-				 if (logCom) Name.append(" REG_EXT");
-				 region_ptr = &wm->m_reg_motion_plus;
-				 break;
-			case 0xa6:
-				 if (logCom) Name.append(" REG_M+");
-				 region_ptr = &wm->m_reg_motion_plus;
+
+			case WIIMOTE_REG_EXT:
+				if (log_com) com.append(" REG_EXT");
+				region_ptr = wm->GetMotionPlusActive() ? (void*)&wm->m_reg_motion_plus : (void*)&wm->m_reg_ext;
+				region_size = WIIMOTE_REG_EXT_SIZE;
 				break;
-			case 0xb0:
-				if (logCom) Name.append(" REG_IR");
+
+			case WIIMOTE_REG_MP:
+				if (log_com) com.append(" REG_M+");
+				if (!wm->GetMotionPlusActive())
+				{
+					region_ptr = &wm->m_reg_motion_plus;
+					region_size = WIIMOTE_REG_EXT_SIZE;
+				}
+				break;
+
+			case WIIMOTE_REG_IR:
+				if (log_com) com.append(" REG_IR");
 				region_ptr = &wm->m_reg_ir;
+				region_size = WIIMOTE_REG_IR_SIZE;
 				break;
 			}
-			//if (!emu && region_ptr)
-				//memcpy(block, (u8*)region_ptr + region_offset, size);
-			//WARN_LOG(CONSOLE, "READING[0x%02x 0x%02x|%d]: %s", data[3], region_offset, size, ArrayToString(block, size, 0, 30).c_str());
-			break;
-		}
 
+			// print data to read
+			//if (region_ptr)
+			//	memcpy(block, (u8*)region_ptr + region_offset, rd->size);
+			//LOG3(CONSOLE, "READING[0x%02x 0x%02x %d]: %s", data[3], region_offset, rd->size, ArrayToString(block, size, 0, 30).c_str());
+
+			break;
+		}}
 		break;
-	}
 
 	case WM_WRITE_SPEAKER_DATA:
-		if (logCom) Name.append("WM_SPEAKER_DATA");
-		size = 21;
+		if (log_audio)
+			com.append("WM_SPEAKER_DATA");
+		else
+			return;
 		break;
 
 	case WM_SPEAKER_MUTE:
-		if (logCom) Name.append("WM_SPEAKER");
-		size = 1;
-		NOTICE_LOG(CONSOLE, "Speaker mute: %d", sr->enable);
+		if (log_com)
+		{
+			com.append("WM_SPEAKER");
+			formatted.append(StringFromFormat("mute: %d", sr->enable));
+		}
 		break;
 
 	case WM_IR_LOGIC:
-		if (logCom) Name.append("WM_IR");
-		size = 1;
+		if (log_com) com.append("WM_IR");
 		break;
 
 	case WM_STATUS_REPORT:
-		size = sizeof(wm_status_report);
-		Name = "WM_STATUS_REPORT";
-		//INFO_LOG(CONSOLE, "WM_STATUS_REPORT: %s", ArrayToString(data, size+2, 0).c_str());
-		{
+	{
+		if (log_com) {
+			com.append("WM_STATUS_REPORT");
 			wm_status_report* pStatus = (wm_status_report*)(data + 2);
-			ERROR_LOG(CONSOLE, ""
-				"Statusreport extension: %i",
-				//"Speaker enabled: %i"
-				//"IR camera enabled: %i"
-				//"LED 1: %i\n"
-				//"LED 2: %i\n"
-				//"LED 3: %i\n"
-				//"LED 4: %i\n"
-				//"Battery low: %i\n"
-				//"Battery level: %i",
-				pStatus->extension
-				//pStatus->speaker,
-				//pStatus->ir,
-				//(pStatus->leds >> 0),
-				//(pStatus->leds >> 1),
-				//(pStatus->leds >> 2),
-				//(pStatus->leds >> 3),
-				//pStatus->battery_low,
-				//pStatus->battery
+
+			formatted = StringFromFormat(
+				"extension: %i"
+				//"speaker enabled: %i"
+				//"IR enabled: %i"
+				//"LED 1: %i"
+				//"LED 2: %i"
+				//"LED 3: %i"
+				//"LED 4: %i"
+				//"Battery low: %i"
+				//"Battery level: %i"
+				, pStatus->extension
+				//, pStatus->speaker
+				//, pStatus->ir
+				//, (pStatus->leds >> 0)
+				//, (pStatus->leds >> 1)
+				//, (pStatus->leds >> 2)
+				//, (pStatus->leds >> 3)
+				//, pStatus->battery_low
+				//, pStatus->battery
 				);
+			// Update the global (for both the real and emulated) extension settings from whatever
+			//   the real Wiimote use. We will enable the extension from the 0x21 report.
+			if(!emu && !pStatus->extension)
+			{
+				//DisableExtensions();
+				//if (m_BasicConfigFrame) m_BasicConfigFrame->UpdateGUI();
+			}
 		}
+
 		break;
+	}
 
 	case WM_READ_DATA_REPLY:
 	{
-		size = sizeof(wm_read_data_reply);
-		Name = "R_REPLY";
+		wm_read_data_reply* const rdr = (wm_read_data_reply*)(data + 2);
+		u16 address = Common::swap16(rdr->address);
+		u8 size = rdr->size + 1;
 
-		u8 data2[32];
-		memset(data2, 0, sizeof(data2));
-		memcpy(data2, data, size_);
-		wm_read_data_reply* const rdr = (wm_read_data_reply*)(data2 + 2);
+		if (address != u16(Common::swap24(g_rd.address)))
+			LOG3(COMMON, "WM_READ_DATA_REPLY address %04x is different from WM_READ_DATA address %06x", address, Common::swap24(g_rd.address));
 
-		bool decrypted = false;
-		if(!dataRep.empty())
+		g_rd.address[2] += size;
+
+		if (log_com)
 		{
-			dataReply[0] = (dataRep.front()>>16)&0x00FF;
-			dataReply[1] = (dataRep.front()>>8)&0x00FF;
-			dataReply[2] = dataRep.front()&0x00FF;
-			dataRep.pop();
+			com.append("READ_REPLY");
+			formatted.append(StringFromFormat("%02x %04x %02x %02x: %s\n", g_rd.space, address, size, rdr->error, ArrayToString(rdr->data, size, 0).c_str()));
 		}
 
-		switch(dataReply[0])
+		switch(g_rd.space)
 		{
 		case WM_SPACE_EEPROM:
-			if (logCom)
-				Name.append(" REG_EEPROM");
+			if (log_com)
+				com.append(" REG_EEPROM");
+
+			//LOG3(CONSOLE, "%s", ArrayToString(rdr->data, size).c_str());
+
+			// save
+			if (save)
+				memcpy(wm->m_eeprom + address, rdr->data, size);
+
 			// Wiimote calibration
-			if(data[4] == 0xf0 && data[5] == 0x00 && data[6] == 0x10) {
-				if(data[6] == 0x10) {
-					accel_cal* calib = (accel_cal*)&rdr->data[6];
-					ERROR_LOG(CONSOLE, "Wiimote calibration:");
-					//SERROR_LOG(CONSOLE, "%s", ArrayToString(rdr->data, rdr->size).c_str());
-					ERROR_LOG(CONSOLE, "Cal_zero.x: %i", calib->zero_g.x);
-					ERROR_LOG(CONSOLE, "Cal_zero.y: %i", calib->zero_g.y);
-					ERROR_LOG(CONSOLE, "Cal_zero.z: %i", calib->zero_g.z);
-					ERROR_LOG(CONSOLE, "Cal_g.x: %i", calib->one_g.x);
-					ERROR_LOG(CONSOLE, "Cal_g.y: %i", calib->one_g.y);
-					ERROR_LOG(CONSOLE, "Cal_g.z: %i", calib->one_g.z);
-					// save
-					if (!emu)
-						memcpy(wm->m_eeprom + 0x16, rdr->data + 6, rdr->size);
-				}
+			if (address == 0x10) {
+				accel_cal* calib = (accel_cal*)&wm->m_eeprom[0x16];
+				formatted = StringFromFormat(
+					"Wiimote calibration\n"
+					"zero x: %u\n"
+					"zero y: %u\n"
+					"zero z: %u\n"
+
+					"g x: %u\n"
+					"g y: %u\n"
+					"g z: %u"
+
+					, calib->zero_g.x
+					, calib->zero_g.y
+					, calib->zero_g.z
+
+					, calib->one_g.x
+					, calib->one_g.y
+					, calib->one_g.z
+					);
 			}
 			break;
 
 		case WM_SPACE_REGS1:
 		case WM_SPACE_REGS2:
-			switch(dataReply[1])
-			{
-			case 0xa2: if (logCom) Name.append(" REG_SPEAKER"); break;
-			case 0xa4: if (logCom) Name.append(" REG_EXT"); break;
-			case 0xa6: if (logCom) Name.append(" REG_M+"); break;
-			case 0xb0: if (logCom) Name.append(" REG_IR"); break;
-			}
-		}
-
-		// save key
-		if (!emu && rdr->address>>8 == 0x40)
 		{
-			memcpy(((u8*)&wm->m_reg_ext.encryption_key), rdr->data, rdr->size+1);
-			wiimote_gen_key(&wm->m_ext_key, wm->m_reg_ext.encryption_key);
-			NOTICE_LOG(CONSOLE, "Reading key: %s", ArrayToString(((u8*)&wm->m_ext_key), sizeof(wm->m_ext_key), 0, 30).c_str());
-		}
-
-		// select decryption
-		//if(((!wm->GetMotionPlusActive() && ((u8*)&wm->m_reg_ext)[0xf0] == 0xaa) || (wm->GetMotionPlusActive() && ((u8*)&wm->m_reg_motion_plus)[0xf0] == 0xaa)) && rdr->address>>8 < 0xf0) {
+			reg_type = Common::swap24(g_rd.address) >> 16;
+			const u8 region_offset = (u8)address;
+			void *region_ptr = NULL;
+			int region_size = 0;
 
-		//if(((((u8*)&wm->m_reg_ext)[0xf0] == 0xaa) || ((u8*)&wm->m_reg_motion_plus)[0xf0] == 0xaa) && rdr->address>>8 < 0xf0) {
+			switch(reg_type)
+			{
+			case WIIMOTE_REG_SPEAKER:
+				if (log_com) com.append(" REG_SPEAKER");
+				region_ptr = &wm->m_reg_speaker;
+				region_size = WIIMOTE_REG_SPEAKER_SIZE;
+				break;
 
-		//if(!wm->GetMotionPlusActive() && ((u8*)&wm->m_reg_ext)[0xf0] == 0xaa && rdr->address>>8 < 0xf0) {
+			case WIIMOTE_REG_EXT:
+				if (log_com) com.append(" REG_EXT");
+				region_ptr = wm->GetMotionPlusActive() ? (void*)&wm->m_reg_motion_plus : (void*)&wm->m_reg_ext;
+				region_size = WIIMOTE_REG_EXT_SIZE;
+				break;
 
-		//if(!wm->GetMotionPlusActive() && ((u8*)&wm->m_reg_ext)[0xf0] == 0xaa) {
+			case WIIMOTE_REG_MP:
+				if (log_com) com.append(" REG_M+");
+				if (!wm->GetMotionPlusActive())
+				{
+					region_ptr = &wm->m_reg_motion_plus;
+					region_size = WIIMOTE_REG_EXT_SIZE;
+				}
+				break;
 
-		//	SWARN_LOG(CONSOLE, "key %s", ArrayToString(((u8*)&wm->m_ext_key), sizeof(wm->m_ext_key), 0, 30).c_str());
-		//	SWARN_LOG(CONSOLE, "decrypt %s", ArrayToString(rdr->data, rdr->size+1, 0, 30).c_str());
-		//	wiimote_decrypt(&wm->m_ext_key, rdr->data, dataReply[2]&0xffff, rdr->size+1);
-		//	SWARN_LOG(CONSOLE, "decrypt %s", ArrayToString(rdr->data, rdr->size+1, 0, 30).c_str());
-		//	decrypted = true;
-		//}
+			case WIIMOTE_REG_IR:
+				if (log_com) com.append(" REG_IR");
+				region_ptr = &wm->m_reg_ir;
+				region_size = WIIMOTE_REG_IR_SIZE;
+				break;
+			}
 
-		// save data
-		if (!emu && !rdr->error)
-		{
-			//if (dataReply[1] == 0xa4 && wm->GetMotionPlusActive())
-				//memcpy(&((u8*)&wm->m_reg_motion_plus)[rdr->address>>8], rdr->data, rdr->size+1);
-			//if (dataReply[1] == 0xa4 && !wm->GetMotionPlusActive())
-			//if (dataReply[1] == 0xa4)
-			//	memcpy(&((u8*)&wm->m_reg_ext)[rdr->address>>8], rdr->data, rdr->size+1);
-			//if (!wm->GetMotionPlusActive() && wm->GetMotionPlusAttached())
-			//if (dataReply[1] == 0xa6)
-			//	memcpy(&((u8*)&wm->m_reg_motion_plus)[rdr->address>>8], rdr->data, rdr->size+1);
-			//INFO_LOG(CONSOLE, "Saving[0x%2x:0x%2x]: %s", dataReply[1], rdr->address>>8, ArrayToString(rdr->data, rdr->size+1).c_str());
-		}
+			if (wm->m_reg_ext.encryption == 0xaa && region_ptr == &wm->m_reg_ext) {
 
-		if (!rdr->error && rdr->address>>8 >= 0xf0 && rdr->address>>8 <= 0xff)
-		{
-			//INFO_LOG(CONSOLE, "Extension ID: %s", ArrayToString(rdr->data, rdr->size+1).c_str());
-		}
+				//formatted.append(StringFromFormat("key %s\n", ArrayToString(((u8*)&wm->m_ext_key), sizeof(wm->m_ext_key), 0, 30).c_str()));
+				formatted.append(StringFromFormat("encrypted %s\n", ArrayToString(rdr->data, size, 0, 30).c_str()));
+				wiimote_decrypt(&wm->m_ext_key, rdr->data, address, size);
+				formatted.append(StringFromFormat("decrypted %s\n", ArrayToString(rdr->data, size, 0, 30).c_str()));
+			}
 
-		// Nunchuck calibration
-		if(data[4] == 0xf0 && data[5] == 0x00 && (data[6] == 0x20 || data[6] == 0x30))
-		{
-			// log
-			//TmpData = StringFromFormat("Read[%s] (enc): %s", (Emu ? "Emu" : "Real"), ArrayToString(data, size + 2).c_str());
+			// save data
+			if (save && !rdr->error && region_ptr == &wm->m_reg_ext && (region_offset + size <= region_size))
+				memcpy((u8*)region_ptr + region_offset, rdr->data, size);
 
-			// decrypt
-			//if(((u8*)&wm->m_reg_ext)[0xf0] == 0xaa) {
-			//	wiimote_decrypt(&wm->m_ext_key, &data[0x07], 0x00, (data[4] >> 0x04) + 1);
-
-			//if (wm->m_extension->name == "NUNCHUCK") {
-			//	INFO_LOG(CONSOLE, "\nGame got the Nunchuck calibration:\n");
-			//	INFO_LOG(CONSOLE, "Cal_zero.x: %i\n", data[7 + 0]);
-			//	INFO_LOG(CONSOLE, "Cal_zero.y: %i\n", data[7 + 1]);
-			//	INFO_LOG(CONSOLE, "Cal_zero.z: %i\n",  data[7 + 2]);
-			//	INFO_LOG(CONSOLE, "Cal_g.x: %i\n", data[7 + 4]);
-			//	INFO_LOG(CONSOLE, "Cal_g.y: %i\n",  data[7 + 5]);
-			//	INFO_LOG(CONSOLE, "Cal_g.z: %i\n",  data[7 + 6]);
-			//	INFO_LOG(CONSOLE, "Js.Max.x: %i\n",  data[7 + 8]);
-			//	INFO_LOG(CONSOLE, "Js.Min.x: %i\n",  data[7 + 9]);
-			//	INFO_LOG(CONSOLE, "Js.Center.x: %i\n", data[7 + 10]);
-			//	INFO_LOG(CONSOLE, "Js.Max.y: %i\n",  data[7 + 11]);
-			//	INFO_LOG(CONSOLE, "Js.Min.y: %i\n",  data[7 + 12]);
-			//	INFO_LOG(CONSOLE, "JS.Center.y: %i\n\n", data[7 + 13]);
-			//}
-			//else // g_Config.bClassicControllerConnected {
-			//	INFO_LOG(CONSOLE, "\nGame got the Classic Controller calibration:\n");
-			//	INFO_LOG(CONSOLE, "Lx.Max: %i\n", data[7 + 0]);
-			//	INFO_LOG(CONSOLE, "Lx.Min: %i\n", data[7 + 1]);
-			//	INFO_LOG(CONSOLE, "Lx.Center: %i\n",  data[7 + 2]);
-			//	INFO_LOG(CONSOLE, "Ly.Max: %i\n", data[7 + 3]);
-			//	INFO_LOG(CONSOLE, "Ly.Min: %i\n",  data[7 + 4]);
-			//	INFO_LOG(CONSOLE, "Ly.Center: %i\n",  data[7 + 5]);
-			//	INFO_LOG(CONSOLE, "Rx.Max.x: %i\n",  data[7 + 6]);
-			//	INFO_LOG(CONSOLE, "Rx.Min.x: %i\n",  data[7 + 7]);
-			//	INFO_LOG(CONSOLE, "Rx.Center.x: %i\n", data[7 + 8]);
-			//	INFO_LOG(CONSOLE, "Ry.Max.y: %i\n",  data[7 + 9]);
-			//	INFO_LOG(CONSOLE, "Ry.Min: %i\n",  data[7 + 10]);
-			//	INFO_LOG(CONSOLE, "Ry.Center: %i\n\n", data[7 + 11]);
-			//	INFO_LOG(CONSOLE, "Lt.Neutral: %i\n",  data[7 + 12]);
-			//	INFO_LOG(CONSOLE, "Rt.Neutral %i\n\n", data[7 + 13]);
-			//}
-
-			// save values
-			if (!emu)
+			if (!rdr->error && address >= 0xf0 && address <= 0xff)
 			{
-				// Save to registry
-				if(data[7 + 0] != 0xff)
+				formatted.append(StringFromFormat("extension ID: %s\n", ArrayToString(rdr->data, size).c_str()));
+				/*
+				u16 id = Common::swap16(*(u16*)rdr->data);
+				int i = 0;
+				for (int i = 0; i < wm->m_extension->attachments.size(); i++)
 				{
-					//memcpy((u8*)&wm->m_reg_ext.calibration, &data[7], 0x10);
-					//memcpy((u8*)&wm->m_reg_ext.unknown3, &data[7], 0x10);
-				}
-				// Save the default values that should work with Wireless Nunchucks
-				else
-				{
-					//WiimoteEmu::SetDefaultExtensionRegistry();
+					WiimoteEmu::Attachment* a = (WiimoteEmu::Attachment*)wm->m_extension->attachments.at(i);
+					u16 id_ = Common::swap16(*(u16*)&a->reg.constant_id[4]);
+					if (id_ == id)
+					{
+						wm->m_extension->active_extension = i;
+						break;
+					}
 				}
-				//WiimoteEmu::UpdateEeprom();
-			}
-			// third party Nunchuck
-			else if(data[7] == 0xff)
-			{
-				//memcpy(wm->m_reg_ext + 0x20, WiimoteEmu::wireless_nunchuck_calibration, sizeof(WiimoteEmu::wireless_nunchuck_calibration));
-				//memcpy(wm->m_reg_ext + 0x30, WiimoteEmu::wireless_nunchuck_calibration, sizeof(WiimoteEmu::wireless_nunchuck_calibration));
+				*/
 			}
 
-			// print encrypted data
-			//INFO_LOG(CONSOLE, "WM_READ_DATA_REPLY: Extension calibration: %s", TmpData.c_str());
-		}
-
-		if (dataReply[1] == 0xa4 || dataReply[1] == 0xa6)
-		{
-			if(rdr->error == 7 || rdr->error == 8)
+			// save key
+			if (save && region_ptr == &wm->m_reg_ext && address == 0x40)
 			{
-				WARN_LOG(CONSOLE, "R%s[0x%02x 0x%02x]: e-%d", decrypted?"*":"", dataReply[1], rdr->address>>8, rdr->error);
+				memcpy(((u8*)&wm->m_reg_ext.encryption_key), rdr->data, size);
+				wiimote_gen_key(&wm->m_ext_key, wm->m_reg_ext.encryption_key);
+				formatted.append(StringFromFormat("reading key: %s", ArrayToString(((u8*)&wm->m_ext_key), sizeof(wm->m_ext_key), 0, 30).c_str()));
 			}
-			else
+
+			// Nunchuk calibration
+			if (region_ptr == &wm->m_reg_ext && address == 0x20)
 			{
-				WARN_LOG(CONSOLE, "R%s[0x%02x 0x%02x|%d]: %s", decrypted?"*":"", dataReply[1], rdr->address>>8, rdr->size+1, ArrayToString(rdr->data, rdr->size+1, 0).c_str());
+				u16 type = *(u16*)&wm->m_reg_ext.constant_id[4];
+
+				if (type == 0x0000)
+				{
+					nu_cal* cal = (nu_cal*)&wm->m_reg_ext.calibration;
+
+					formatted.append(StringFromFormat(
+					"Nunchuk calibration\n"
+
+					"zero x: %u\n"
+					"zero y: %u\n"
+					"zero z: %u\n"
+					"g x: %u\n"
+					"g y: %u\n"
+					"g z: %u\n"
+
+					"j x center: %u\n"
+					"j x max: %i\n"
+					"j x min: %i\n"
+
+					"j y center: %u\n"
+					"j y max: %u\n"
+					"j y min: %u"
+
+					, cal->cal_zero.x
+					, cal->cal_zero.y
+					, cal->cal_zero.z
+
+					, cal->cal_g.x
+					, cal->cal_g.y
+					, cal->cal_g.z
+
+					, cal->jx.center
+					, cal->jx.max
+					, cal->jx.min
+
+					, cal->jy.center
+					, cal->jy.max
+					, cal->jy.min
+					));
+				}
+
+				else if (type == 0x0101)
+				{
+					cc_cal* cal = (cc_cal*)&rdr->data;
+
+					formatted.append(StringFromFormat(
+						"Classic Controller calibration\n"
+
+						"l x center: %u\n"
+						"l x max: %u\n"
+						"l x min: %u\n"
+
+						"l y center: %u\n"
+						"l y max: %u\n"
+						"l y min: %u\n"
+
+						"r x center.x: %u\n"
+						"r x max.x: %u\n"
+						"r x min.x: %u\n"
+
+						"r y center: %u\n"
+						"r y max.y: %u\n"
+						"r y min: %u\n"
+
+						"lt neutral: %u\n"
+						"rt neutral %u"
+
+						, cal->Lx.center
+						, cal->Lx.max
+						, cal->Lx.min
+
+						, cal->Ly.center
+						, cal->Ly.max
+						, cal->Ly.min
+
+						, cal->Rx.center
+						, cal->Rx.max
+						, cal->Rx.min
+
+						, cal->Ry.center
+						, cal->Ry.max
+						, cal->Ry.min
+
+						, cal->Tl.neutral
+						, cal->Tr.neutral
+						));
+				}
 			}
+
+			break;
+		}
 		}
 
-		break;
-	}
+			break;
+		}
 
 	case WM_ACK_DATA:
-		size = sizeof(wm_acknowledge);
-		Name = "WM_ACK_DATA";
-		//INFO_LOG(CONSOLE, "ACK 0x%02x", data[4]);
+	{
+		wm_acknowledge* const ack = (wm_acknowledge*)sr->data;
+		if (log_com) com.append(StringFromFormat("WM_ACK_DATA %02x %02x", ack->reportID, ack->errorID));
 		break;
+	}
 
 	case WM_REPORT_CORE:
-		size = sizeof(wm_report_core);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_ACCEL:
-		size = sizeof(wm_report_core_accel);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_EXT8:
-		size = sizeof(wm_report_core_accel_ir12);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_ACCEL_IR12:
-		size = sizeof(wm_report_core_accel_ir12);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_EXT19:
-		size = sizeof(wm_report_core_accel_ext16);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_ACCEL_EXT16:
-		size = sizeof(wm_report_core_accel_ext16);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_IR10_EXT9:
-		size = sizeof(wm_report_core_accel_ir10_ext6);
-		DataReport = true;
-		break;
 	case WM_REPORT_CORE_ACCEL_IR10_EXT6:
-		size = sizeof(wm_report_core_accel_ir10_ext6);
-		DataReport = true;
+		data_report = true;
 		break;
 
 	default:
-		size = 15;
-		NOTICE_LOG(CONSOLE, "Debugging[%s]: Unknown channel 0x%02x", (emu ? "E" : "R"), data[1]);
+		if (log_com)
+			com = StringFromFormat("unknown report 0x%02x", sr->wm);
 		break;
 	}
 
-	//if (DataReport && wm->GetMotionPlusActive())
+	if (data_report)
+		report_mode = data[1];
+
+	//if (data_report && wm->GetMotionPlusActive())
 	//{
 	//	if (data[1] == WM_REPORT_CORE_ACCEL_IR10_EXT6)
 	//		static bool extension = false;
 	//	if (extension != (bool)(data[17+4]&1))
-	//		ERROR_LOG(CONSOLE, "Datareport extension %d", data[17+4]&1);
+	//		LOG3(CONSOLE, "Datareport extension %d", data[17+4]&1);
 	//		extension = data[17+4]&1;
 	//}
 
-	if (!DataReport && logCom && size <= 30)
+	if (log_com && !com.empty())
 	{
-		ERROR_LOG_S(CONSOLE, "Com[%s] %s: %s", (emu ? "E" : "R"), Name.c_str(), ArrayToString(data, size + 2, 0).c_str());
+		switch(sr->wm)
+		{
+		case WM_WRITE_DATA:
+		case WM_READ_DATA:
+		case WM_READ_DATA_REPLY:
+			switch(reg_type)
+			{
+			case WIIMOTE_REG_EXT:
+				LOG6(CONSOLE, "com[%s] %s", emu ? "E" : "R", com.c_str());
+				break;
+			default:
+				LOG8(CONSOLE, "com[%s] %s", emu ? "E" : "R", com.c_str());
+				break;
+			}
+			break;
+
+		default:
+			LOG2(CONSOLE, "com[%s] %s", emu ? "E" : "R", com.c_str());
+		}
+
+		if (!formatted.empty())
+			LOG1(CONSOLE, "%s", formatted.c_str());
 	}
 
-	if (logAudio && AudioData)
+	if (log_audio && audio_data)
 	{
-		//DEBUG_LOG(CONSOLE, "%s: %s\n", Name.c_str(), ArrayToString(data, std::min(10,size), 0, 30).c_str());
+		//DEBUG_LOG(CONSOLE, "%s: %s\n", com.c_str(), ArrayToString(data, min(10, data_size), 0, 30).c_str());
 	}
 
-	if (DataReport && (logData || logMP))
+	if (data_report && (log_data || log_mp))
 	{
-		// decrypt extension data
-		//if (data[1] == 0x37 && !wm->GetMotionPlusActive())
-		//if (data[1] == 0x37)
-		//	wiimote_decrypt(&wm->m_ext_key, &data[17], 0x00, 0x06);
-		//if (data[1] == 0x35)
-		//	wiimote_decrypt(&wm->m_ext_key, &data[7], 0x00, 0x06);
+		u8 mode = data[1];
+		const ReportFeatures& rptf = reporting_mode_features[mode - WM_REPORT_CORE];
 
-		//if (data[1] == 0x35 || data[1] == 0x37)
-		//{
-		//	if (!g_DebugMP && mp->is_mp_data) return;
-		//	if (!g_DebugData && !mp->is_mp_data) return;
-		//}
+		//if (wm->m_reporting_mode != mode)
+			//LOG2(WIIMOTE, "state mode %x, data mode %x", wm->m_reporting_mode, mode);
 
-		std::string SCore = "", SAcc = "", SIR = "", SExt = "", SExtID = "";
+		string s_core = "", s_acc = "", s_ir = "", s_ext = "", s_ext_id = "";
 
 		wm_core* core = (wm_core*)sr->data;
 		accel_cal* calib = (accel_cal*)&wm->m_eeprom[0x16];
 		wm_accel* accel = (wm_accel*)&data[4];
 
-		//SCore = StringFromFormat(
-		//	"%d %d %d %d ",
-		//	core->xL,
-		//	core->yL,
-		//	core->zL,
-		//	core->unknown);
-
-		SAcc = StringFromFormat(
+		s_acc = StringFromFormat(
+			//"%3d %3d %3d"
 			//"%3d %3d %3d"
-			//" | %3d %3d %3d"
-			//" | %3d %3d %3d"
-			"| %5.2f %5.2f %5.2f"
+			//"%3d %3d %3d"
+			"%5.2f %5.2f %5.2f"
+
 			//, calib->zero_g.x, calib->zero_g.y, calib->zero_g.z
-			//, (calib->zero_g.x<<2) + calib->zero_g.xL, (calib->zero_g.y<<2) + calib->zero_g.yL, (calib->zero_g.z<<2) + calib->zero_g.zL
+
+			//, (calib->zero_g.x<<2) + calib->zero_g.xL, (calib->zero_g.y<<2) + calib->zero_g.yL, (calib->zero_g.z << 2) + calib->zero_g.zL
+
 			//, calib->one_g.x, calib->one_g.y, calib->one_g.z
-			//, (calib->one_g.x<<2) + calib->one_g.xL, (calib->one_g.y<<2) + calib->one_g.yL, (calib->one_g.z<<2) + calib->one_g.zL
+			//, (calib->one_g.x << 2) + calib->one_g.xL, (calib->one_g.y << 2) + calib->one_g.yL, (calib->one_g.z << 2) + calib->one_g.zL
+
 			//, accel->x, accel->y, accel->z
-			//, (accel->x<<2) + core->xL, (accel->y<<2) + core->yL, (accel->z<<2) + core->zL
-			, (accel->x - calib->zero_g.x) / float(calib->one_g.x-calib->zero_g.x), (accel->y - calib->zero_g.y) / float(calib->one_g.y-calib->zero_g.y), (accel->z - calib->zero_g.z) / float(calib->one_g.z-calib->zero_g.z));
+			//, (accel->x << 2) + core->xL, (accel->y << 2) + core->yL, (accel->z << 2) + core->zL
 
-		NOTICE_LOG(CONSOLE, "%d", size);
+			, (accel->x - calib->zero_g.x) / float(calib->one_g.x - calib->zero_g.x)
+			, (accel->y - calib->zero_g.y) / float(calib->one_g.y - calib->zero_g.y)
+			, (accel->z - calib->zero_g.z) / float(calib->one_g.z - calib->zero_g.z));
 
-		if (data[1] == WM_REPORT_CORE_ACCEL_IR12)
+		if (rptf.ir)
 		{
-			wm_ir_extended *ir = (wm_ir_extended*)&data[7];
-
-			SIR = StringFromFormat(
-				"%4u %4u | %u"
-				, ir->x | ir->xhi << 8
-				, ir->y | ir->yhi << 8
-				, ir->size);
-		}
+			if (mode == WM_REPORT_CORE_ACCEL_IR12)
+			{
+				wm_ir_extended *ir = (wm_ir_extended*)&data[rptf.ir];
 
-		if (data[1] == WM_REPORT_CORE_ACCEL_EXT16)
-		{
-			wm_extension *nc = (wm_extension*)&data[7];
+				s_ir = StringFromFormat(
+					"%4u %4u | %u"
+					, ir->x | ir->xhi << 8
+					, ir->y | ir->yhi << 8
+					, ir->size);
+			}
 
-			SExt = StringFromFormat(
-				"%02x %02x | %02x %02x %02x | %02x"
-				, nc->jx, nc->jy
-				, nc->ax, nc->ay, nc->az
-				, nc->bt);
+			else if (mode == WM_REPORT_CORE_ACCEL_IR10_EXT6)
+			{
+				wm_ir_basic *ir = (wm_ir_basic*)&data[rptf.ir];
+
+				s_ir = StringFromFormat(
+					"%4u %4u %4u %4u"
+					, ir->x1 | ir->x1hi << 8
+					, ir->y1 | ir->y1hi << 8
+					, ir->x2 | ir->x2hi << 8
+					, ir->y2 | ir->y1hi << 8);
+			}
 		}
 
-		if (data[1] == WM_REPORT_CORE_ACCEL_IR10_EXT6)
+		if (rptf.ext)
 		{
-			wm_ir_basic *ir = (wm_ir_basic*)&data[7];
+			// decrypt
+			//if (wm->m_reg_ext.encryption == 0xaa && !wm->GetMotionPlusActive())
+			if (wm->m_reg_ext.encryption == 0xaa)
+				wiimote_decrypt(&wm->m_ext_key, &data[rptf.ext], 0x00, 0x06);
 
-			SIR = StringFromFormat(
-				"%4u %4u %4u %4u"
-				, ir->x1 | ir->x1hi << 8
-				, ir->y1 | ir->y1hi << 8
-				, ir->x2 | ir->x2hi << 8
-				, ir->y2 | ir->y1hi << 8);
+			if (wm->GetMotionPlusActive())
+			{
+				/*
+				wm_motionplus_data *mp = (wm_motionplus_data*)&data[17];
+				wm_nc_mp *nc_mp = (wm_nc_mp*)&data[17];
 
-			/*
-			wm_motionplus *mp = (wm_motionplus*)&data[17];
-			wm_nc_mp  *nc_mp = (wm_nc_mp *)&data[17];
+				if (!log_mp && mp->is_mp_data)
+					return;
+				if (!log_data && !mp->is_mp_data)
+					return;
 
-			if (mp->is_mp_data)
-			{
-				SExt = StringFromFormat(""
-					//"%02x %02x %02x %02x %02x %02x"
-					//"| %04x %04x %04x
-					" %5.2f %5.2f %5.2f"
-					" %s%s%s"
-					//, mp->roll1, mp->roll2
-					//, mp->pitch1, mp->pitch2
-					//, mp->yaw1, mp->yaw2
-					//, mp->pitch2<<8 | mp->pitch1
-					//, mp->roll2<<8 | mp->roll1
-					//, mp->yaw2<<8 | mp->yaw1
-					//, mp->pitch2<<8 | mp->pitch1
-					//, mp->roll2<<8 | mp->roll1
-					//, mp->yaw2<<8 | mp->yaw1
-					, float((mp->pitch2<<8 | mp->pitch1) - 0x1f7f) / float(0x1fff)
-					, float((mp->roll2<<8 | mp->roll1) - 0x1f7f) / float(0x1fff)
-					, float((mp->yaw2<<8 | mp->yaw1) - 0x1f7f) / float(0x1fff)
-					, mp->pitch_slow?"*":" ", mp->roll_slow?"*":" ", mp->yaw_slow?"*":" ");
+				if (mp->is_mp_data)
+				{
+					s_ext = StringFromFormat(""
+						//"%02x %02x %02x %02x %02x %02x"
+						//"| %04x %04x %04x
+						" %5.2f %5.2f %5.2f"
+						" %s%s%s"
+						//, mp->roll1, mp->roll2
+						//, mp->pitch1, mp->pitch2
+						//, mp->yaw1, mp->yaw2
+						//, mp->pitch2<<8 | mp->pitch1
+						//, mp->roll2<<8 | mp->roll1
+						//, mp->yaw2<<8 | mp->yaw1
+						//, mp->pitch2<<8 | mp->pitch1
+						//, mp->roll2<<8 | mp->roll1
+						//, mp->yaw2<<8 | mp->yaw1
+						, float((mp->pitch2<<8 | mp->pitch1) - 0x1f7f) / float(0x1fff)
+						, float((mp->roll2<<8 | mp->roll1) - 0x1f7f) / float(0x1fff)
+						, float((mp->yaw2<<8 | mp->yaw1) - 0x1f7f) / float(0x1fff)
+						, mp->pitch_slow?"*":" ", mp->roll_slow?"*":" ", mp->yaw_slow?"*":" ");
+				}
+				else
+				{
+					s_ext = StringFromFormat(
+						"%02x %02x | %02x %02x | %02x %02x %02x | %02x %02x %02x",
+						nc_mp->bt.z, nc_mp->bt.c,
+						nc_mp->jx, nc_mp->jy,
+						nc_mp->ax + nc_mp->axL, nc_mp->ay + nc_mp->ayL, (nc_mp->az << 1) + nc_mp->azL);
+				}
+
+				s_ext_id = StringFromFormat(
+					"%s %d %d"
+					, mp->is_mp_data ? "+" : "e"
+					, mp->is_mp_data ? mp->extension_connected : wm_nc_mp->extension_connected
+					, wm->m_extension->active_extension);
+				*/
 			}
 			else
 			{
-				SExt = StringFromFormat(
-					"%02x %02x | %02x %02x | %02x %02x %02x | %02x %02x %02x",
-					nc_mp->bz, nc_mp->bc,
-					nc_mp->jx, nc_mp->jy,
-					nc_mp->ax+nc_mp->axL, nc_mp->ay+nc_mp->ayL, (nc_mp->az<<1)+nc_mp->azL);
-			}
+				nu_cal *cal = (nu_cal*)&wm->m_reg_ext.calibration;
+				wm_nc *nc = (wm_nc*)&data[rptf.ext];
 
-			SExtID = StringFromFormat(
-				"[%s|%d|%d]"
-				, mp->is_mp_data ? "+" : "e"
-				, mp->is_mp_data ? mp->extension_connected : nc_mp->extension_connected
-				, wm->m_extension->active_extension);
-			*/
+				s_ext = StringFromFormat(
+					"%d %d"
+
+					", %3u %3u"
+					", %.2f [%.2f, %.2f] %.2f [%.2f, %.2f]"
+
+					", %4d %4d %4d"
+					, nc->bt.z, nc->bt.c
 
-			//DEBUG_LOG_S(CONSOLE, "M+ %d Extension %d %d %s", mp->is_mp_data, mp->is_mp_data ?
+					, nc->jx, nc->jy
+
+					, double(nc->jx - cal->jx.center) / (double(abs(cal->jx.min - cal->jx.center) + abs(cal->jx.max - cal->jx.center)) / 2.0)
+					, double(cal->jx.min - cal->jx.center) / double(abs(cal->jx.min - cal->jx.center))
+					, double(cal->jx.max - cal->jx.center) /double(abs(cal->jx.max - cal->jx.center))
+
+					, double(nc->jy - cal->jy.center) / (double(abs(cal->jy.min - cal->jy.center) + abs(cal->jy.max - cal->jy.center)) / 2.0)
+					, double(cal->jy.min - cal->jy.center) / double(abs(cal->jy.min - cal->jx.center))
+					, double(cal->jy.max - cal->jy.center) / double(abs(cal->jy.max - cal->jx.center))
+
+					, nc->ax
+					, nc->ay
+					, nc->az
+
+					//, (nc->ax << 1) + nc->axL
+					//, (nc->ay << 1) + nc->ayL
+					//, (nc->az << 1) + nc->azL
+					);
+			}
+
+			//LOG1(CONSOLE, "M+ %d Extension %d %d %s", mp->is_mp_data, mp->is_mp_data ?
 			//		mp->extension_connected : ((wm_nc_mp*)&data[17])->extension_connected, wm->m_extension->active_extension,
 			//		ArrayToString(((u8*)&wm->m_reg_motion_plus.ext_identifier), sizeof(wm->m_reg_motion_plus.ext_identifier), 0).c_str());
 		}
 
-		// select log data
-		WARN_LOG_S(CONSOLE, "Data"
-			"[%s]"
-			" | id %s"
-			" | %s"
-			" | c %s"
-			" | a %s"
-			" | ir %s"
-			" | ext %s"
-			//" | %s"
-			//" | %s"
-			//" | %s"
-			, (emu ? "E" : "R")
-			, SExtID.c_str()
-			, ArrayToString(data, 2, 0).c_str()
-			, SCore.c_str()
-			, SAcc.c_str()
-			, SIR.c_str()
-			, SExt.c_str()
-			//, ArrayToString(&data[4], 3, 0).c_str()
-			//, (accel->x - 0x7f) / float(0xff), (accel->y - 0x7f) / float(0xff), (accel->z - 0x7f) / float(0xff)
-			//, ArrayToString(&data[17], 6, 0).c_str(),
-			);
+		// log data
+		string s_data = StringFromFormat("data[%s] %02x:", (emu ? "E" : "R"), report_mode);
+
+		if (!s_ext_id.empty())
+			s_data.append(StringFromFormat(" | e %s", s_ext_id.c_str()));
+
+		if (!s_core.empty())
+			s_data.append(StringFromFormat(" | c %s", s_core.c_str()));
+
+		if (!s_acc.empty())
+			s_data.append(StringFromFormat(" | a %s", s_acc.c_str()));
+
+		if (!s_ir.empty())
+			s_data.append(StringFromFormat(" | ir %s", s_ir.c_str()));
+
+		if (!s_ext.empty())
+			s_data.append(StringFromFormat(" | ext %s", s_ext.c_str()));
+
+		// unformatted
+		//s_data = StringFromFormat("data[%s]: %s", (emu ? "E" : "R"), ArrayToString(data, rptf.size).c_str());
+
+		// data report changed
+		u16 unset = 0x20 | 0x40 | 0x80 | 0x2000 | 0x4000;
+		*(u16*)&data[rptf.core] &= ~unset;
+
+		// ignore ir because it change often
+		if (rptf.ir)
+		{
+			if (rptf.ext)
+				memset(&data[rptf.ir], 0xff, rptf.ext - rptf.ir);
+			else
+				memset(&data[rptf.ir], 0xff, rptf.size - rptf.ir);
+		}
+
+		wm_accel &acc = *(wm_accel*)&data[rptf.accel];
+		wm_accel &acc_last = *(wm_accel*)&last_data.data[rptf.accel];
+		if (abs(acc.x - acc_last.x) < 10)
+			acc_last.x = acc.x;
+		if (abs(acc.y - acc_last.y) < 10)
+			acc_last.y = acc.y;
+		if (abs(acc.z - acc_last.z) < 10)
+			acc_last.z = acc.z;
+
+		if (rptf.ext)
+		{
+			wm_nc &ext = *(wm_nc*)&data[rptf.ext];
+			wm_nc &ext_last = *(wm_nc*)&last_data.data[rptf.ext];
+			if (abs(ext.ax - ext_last.ax) < 10)
+				ext_last.ax = ext.ax;
+			if (abs(ext.ay - ext_last.ay) < 10)
+				ext_last.ay = ext.ay;
+			if (abs(ext.az - ext_last.az) < 10)
+				ext_last.az = ext.az;
+			ext.bt.axL = 0;
+			ext.bt.ayL = 0;
+			ext.bt.azL = 0;
+		}
+
+		bool data_report_change = memcmp(last_data.data, data, rptf.size);
+
+		if (data_report_change)
+			LOG3(CONSOLE, "%s", s_data.c_str());
+		else
+			LOG4(CONSOLE, "%s", s_data.c_str());
+
+		memcpy(last_data.data, data, rptf.size);
+		last_data.type = sr->wm;
 	}
 #endif
 }
